//<editor-fold defaultstate="collapsed" desc=" license ">
/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
//</editor-fold>


package org.visnow.vn.lib.gui.ComponentBasedUI;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagLayout;
import javax.swing.AbstractListModel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author know
 */
public class ComponentFeatureListUI extends javax.swing.JPanel implements FeatureUI
{
    protected boolean userUpdate = true;
    protected ComponentFeature componentFeature = null;
    protected ChangeListener listener = new ChangeListener()
    {
        @Override
        public void stateChanged(ChangeEvent e)
        {
            paramsChange();
        }
    };

    /**
     * Creates new form ComponentFeatureUI
     */
    public ComponentFeatureListUI()
    {
        initComponents();
    }

    /**
     * Creates new form ComponentFeatureUI
     * @param showResetButton shows if reset button is visible (and enabled)
     */
    public ComponentFeatureListUI(boolean showResetButton)
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new JPanel();
        jScrollPane1 = new JScrollPane();
        componentList = new JList<>();

        setLayout(new BorderLayout());

        jPanel1.setLayout(new GridBagLayout());
        add(jPanel1, BorderLayout.NORTH);

        jScrollPane1.setMinimumSize(new Dimension(200, 60));
        jScrollPane1.setPreferredSize(new Dimension(250, 130));

        componentList.setModel(new AbstractListModel<String>() {
            String[] strings = { " " };
            public int getSize() { return strings.length; }
            public String getElementAt(int i) { return strings[i]; }
        });
        componentList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        jScrollPane1.setViewportView(componentList);

        add(jScrollPane1, BorderLayout.NORTH);
    }// </editor-fold>//GEN-END:initComponents

    public void setComponentFeature(ComponentFeature componentFeature)
    {
        this.componentFeature = componentFeature;
        componentFeature.setListUI(this);
        setComponentNames(componentFeature.getComponentNames());
        if (componentFeature.getComponentName() != null)
            componentList.setSelectedValue(componentFeature.getComponentName(), true);
        else if (componentFeature.isAddNull())
            componentList.setSelectedValue("null", true);
    }

    public void setComponentNames(String[] componentNames)
    {
        componentList.setListData(componentNames);
    }

    public void setSelectedName(String componentName)
    {
        componentList.setSelectedValue(componentName, true);
    }

    /**
     * used to notify subclasses of component selection change (to enable/disable gui if null component hasbeen selected)
     * @param isNull true if null has been selected
     */
    protected void updateUIToNewComponent(boolean isNull)
    {
    }

    protected void paramsChange()
    {
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected JList<String> componentList;
    protected JPanel jPanel1;
    protected JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables

}
